package ml2java.parser;

import java.io.Reader;
import java.io.FileReader;
import java.io.IOException;
import java.util.NoSuchElementException;
import java.util.Objects;

import ml2java.util.*;

import static ml2java.util.SimpleList.*;
import static ml2java.util.Pair.*;
import static ml2java.util.Option.*;
import static ml2java.util.Bind.*;


public abstract class Token {
    
    public static Token T_Int(Integer field1) {
        return new T_Int(field1);
    }
    public static Token T_Ident(String field1) {
        return new T_Ident(field1);
    }
    public static Token T_WHILE() {
        return new T_WHILE();
    }
    public static Token T_IF() {
        return new T_IF();
    }
    public static Token T_THEN() {
        return new T_THEN();
    }
    public static Token T_ELSE() {
        return new T_ELSE();
    }
    public static Token T_RETURN() {
        return new T_RETURN();
    }
    public static Token T_PLUS() {
        return new T_PLUS();
    }
    public static Token T_MINUS() {
        return new T_MINUS();
    }
    public static Token T_TIMES() {
        return new T_TIMES();
    }
    public static Token T_SLASH() {
        return new T_SLASH();
    }
    public static Token T_EQUAL() {
        return new T_EQUAL();
    }
    public static Token T_LESS() {
        return new T_LESS();
    }
    public static Token T_GREATER() {
        return new T_GREATER();
    }
    public static Token T_LESSEQ() {
        return new T_LESSEQ();
    }
    public static Token T_GREATEREQ() {
        return new T_GREATEREQ();
    }
    public static Token T_LPAR() {
        return new T_LPAR();
    }
    public static Token T_RPAR() {
        return new T_RPAR();
    }
    public static Token T_LCURL() {
        return new T_LCURL();
    }
    public static Token T_RCURL() {
        return new T_RCURL();
    }
    public static Token T_LSQUARE() {
        return new T_LSQUARE();
    }
    public static Token T_RSQUARE() {
        return new T_RSQUARE();
    }
    public static Token T_COMMA() {
        return new T_COMMA();
    }
    public static Token T_COLON() {
        return new T_COLON();
    }
    public static Token T_SEMI() {
        return new T_SEMI();
    }
    public static Token T_DBLEQUAL() {
        return new T_DBLEQUAL();
    }
    public static Token T_NOTEQUAL() {
        return new T_NOTEQUAL();
    }
    public static Token T_AND() {
        return new T_AND();
    }
    public static Token T_OR() {
        return new T_OR();
    }
    
    public abstract <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29);
    
    public abstract <R> R accept(TokenVisitor<R> v);
    
    public interface TokenVisitor<R> {
    
        public R visitT_Int(Integer i);
        public R visitT_Ident(String s);
        public R visitT_WHILE();
        public R visitT_IF();
        public R visitT_THEN();
        public R visitT_ELSE();
        public R visitT_RETURN();
        public R visitT_PLUS();
        public R visitT_MINUS();
        public R visitT_TIMES();
        public R visitT_SLASH();
        public R visitT_EQUAL();
        public R visitT_LESS();
        public R visitT_GREATER();
        public R visitT_LESSEQ();
        public R visitT_GREATEREQ();
        public R visitT_LPAR();
        public R visitT_RPAR();
        public R visitT_LCURL();
        public R visitT_RCURL();
        public R visitT_LSQUARE();
        public R visitT_RSQUARE();
        public R visitT_COMMA();
        public R visitT_COLON();
        public R visitT_SEMI();
        public R visitT_DBLEQUAL();
        public R visitT_NOTEQUAL();
        public R visitT_AND();
        public R visitT_OR();
    
    }
    public static abstract class TokenDefaultVisitor<R> implements TokenVisitor<R> {
    
        public R visitT_Int(Integer i) {
            return visitDefault();
        }
        public R visitT_Ident(String s) {
            return visitDefault();
        }
        public R visitT_WHILE() {
            return visitDefault();
        }
        public R visitT_IF() {
            return visitDefault();
        }
        public R visitT_THEN() {
            return visitDefault();
        }
        public R visitT_ELSE() {
            return visitDefault();
        }
        public R visitT_RETURN() {
            return visitDefault();
        }
        public R visitT_PLUS() {
            return visitDefault();
        }
        public R visitT_MINUS() {
            return visitDefault();
        }
        public R visitT_TIMES() {
            return visitDefault();
        }
        public R visitT_SLASH() {
            return visitDefault();
        }
        public R visitT_EQUAL() {
            return visitDefault();
        }
        public R visitT_LESS() {
            return visitDefault();
        }
        public R visitT_GREATER() {
            return visitDefault();
        }
        public R visitT_LESSEQ() {
            return visitDefault();
        }
        public R visitT_GREATEREQ() {
            return visitDefault();
        }
        public R visitT_LPAR() {
            return visitDefault();
        }
        public R visitT_RPAR() {
            return visitDefault();
        }
        public R visitT_LCURL() {
            return visitDefault();
        }
        public R visitT_RCURL() {
            return visitDefault();
        }
        public R visitT_LSQUARE() {
            return visitDefault();
        }
        public R visitT_RSQUARE() {
            return visitDefault();
        }
        public R visitT_COMMA() {
            return visitDefault();
        }
        public R visitT_COLON() {
            return visitDefault();
        }
        public R visitT_SEMI() {
            return visitDefault();
        }
        public R visitT_DBLEQUAL() {
            return visitDefault();
        }
        public R visitT_NOTEQUAL() {
            return visitDefault();
        }
        public R visitT_AND() {
            return visitDefault();
        }
        public R visitT_OR() {
            return visitDefault();
        }
        public abstract R visitDefault();
    
    }
}

class T_Int extends Token { 
    final Integer field1;
    public T_Int(Integer field1) {
        this.field1 = field1;
    }
    @Override
    public int hashCode() {
        return Objects.hash(field1);
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass())
                    && this.field1.equals(((T_Int)other).field1));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f1.apply(field1);
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_Int(field1);
    }
}
class T_Ident extends Token { 
    final String field1;
    public T_Ident(String field1) {
        this.field1 = field1;
    }
    @Override
    public int hashCode() {
        return Objects.hash(field1);
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass())
                    && this.field1.equals(((T_Ident)other).field1));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f2.apply(field1);
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_Ident(field1);
    }
}
class T_WHILE extends Token { 
    public T_WHILE() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f3.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_WHILE();
    }
}
class T_IF extends Token { 
    public T_IF() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f4.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_IF();
    }
}
class T_THEN extends Token { 
    public T_THEN() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f5.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_THEN();
    }
}
class T_ELSE extends Token { 
    public T_ELSE() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f6.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_ELSE();
    }
}
class T_RETURN extends Token { 
    public T_RETURN() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f7.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_RETURN();
    }
}
class T_PLUS extends Token { 
    public T_PLUS() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f8.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_PLUS();
    }
}
class T_MINUS extends Token { 
    public T_MINUS() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f9.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_MINUS();
    }
}
class T_TIMES extends Token { 
    public T_TIMES() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f10.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_TIMES();
    }
}
class T_SLASH extends Token { 
    public T_SLASH() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f11.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_SLASH();
    }
}
class T_EQUAL extends Token { 
    public T_EQUAL() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f12.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_EQUAL();
    }
}
class T_LESS extends Token { 
    public T_LESS() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f13.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_LESS();
    }
}
class T_GREATER extends Token { 
    public T_GREATER() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f14.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_GREATER();
    }
}
class T_LESSEQ extends Token { 
    public T_LESSEQ() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f15.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_LESSEQ();
    }
}
class T_GREATEREQ extends Token { 
    public T_GREATEREQ() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f16.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_GREATEREQ();
    }
}
class T_LPAR extends Token { 
    public T_LPAR() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f17.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_LPAR();
    }
}
class T_RPAR extends Token { 
    public T_RPAR() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f18.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_RPAR();
    }
}
class T_LCURL extends Token { 
    public T_LCURL() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f19.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_LCURL();
    }
}
class T_RCURL extends Token { 
    public T_RCURL() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f20.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_RCURL();
    }
}
class T_LSQUARE extends Token { 
    public T_LSQUARE() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f21.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_LSQUARE();
    }
}
class T_RSQUARE extends Token { 
    public T_RSQUARE() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f22.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_RSQUARE();
    }
}
class T_COMMA extends Token { 
    public T_COMMA() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f23.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_COMMA();
    }
}
class T_COLON extends Token { 
    public T_COLON() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f24.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_COLON();
    }
}
class T_SEMI extends Token { 
    public T_SEMI() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f25.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_SEMI();
    }
}
class T_DBLEQUAL extends Token { 
    public T_DBLEQUAL() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f26.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_DBLEQUAL();
    }
}
class T_NOTEQUAL extends Token { 
    public T_NOTEQUAL() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f27.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_NOTEQUAL();
    }
}
class T_AND extends Token { 
    public T_AND() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f28.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_AND();
    }
}
class T_OR extends Token { 
    public T_OR() {
    }
    @Override
    public int hashCode() {
        return Objects.hash();
    }
    @Override
    public boolean equals(Object other) {
        if (other == null) return false;
        return (this.getClass() == (other.getClass()));
    }
    public <R> R match(Function1<Integer, R> f1, Function1<String, R> f2, Function0<R> f3, Function0<R> f4, Function0<R> f5, Function0<R> f6, Function0<R> f7, Function0<R> f8, Function0<R> f9, Function0<R> f10, Function0<R> f11, Function0<R> f12, Function0<R> f13, Function0<R> f14, Function0<R> f15, Function0<R> f16, Function0<R> f17, Function0<R> f18, Function0<R> f19, Function0<R> f20, Function0<R> f21, Function0<R> f22, Function0<R> f23, Function0<R> f24, Function0<R> f25, Function0<R> f26, Function0<R> f27, Function0<R> f28, Function0<R> f29) {
        return f29.apply();
    }
    public <R> R accept(TokenVisitor<R> v) {
        return v.visitT_OR();
    }
}

