package ml2java.util;

import java.util.Map.Entry;
import java.util.Objects;

public class Pair<A, B> implements Entry<A,B> {
	A field1;
	B field2;

	public Pair(A field1, B field2) {
		this.field1 = field1;
		this.field2 = field2;
	}
	
	@Override 
	public int hashCode() {
	     return Objects.hash(field1, field2);
	 }

	@SuppressWarnings("unchecked")
	@Override
	public boolean equals(Object other) {
		if (other == null) return false;
		return (this.getClass() == other.getClass()
				&& this.field1.equals(((Pair<A, B>)other).field1)
				&& this.field2.equals(((Pair<A, B>)other).field2));
	}

	public static <A, B> Pair<A, B> Pair(A field1, B field2) {
		return new Pair<A, B>(field1, field2);
	}

	public <R> R match(Function2<A, B, R> f1) {
		return f1.apply(field1, field2);
	}
	
	public A fst() {
		return field1;
	}

	public B snd() {
		return field2;
	}

	@Override
	public A getKey() {
		return field1;
	}

	@Override
	public B getValue() {
		return field2;
	}

	@Override
	public B setValue(B value) {
		B oldValue = field2;
		field2 = value;
		return oldValue;
	}
}
